const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const item_costs = sequelize.define(
    'item_costs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

material_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

labor_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

overhead_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

standard_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

effective_from: {
        type: DataTypes.DATE,
      
      

      },

effective_to: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  item_costs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













































//end loop



    db.item_costs.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.item_costs.belongsTo(db.plants, {
      as: 'plant',
      foreignKey: {
        name: 'plantId',
      },
      constraints: false,
    });




    db.item_costs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.item_costs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return item_costs;
};


